/*  ベクトルの内積 */
#include <stdio.h>

void vector_print(double *, int);
double inner_product(int, double *, double *);

int main()
{
  int size=2;
  double v1[2]={1.0, 2.0};
  double v2[2]={4.0, 8.0};

  vector_print(v1, size);
  vector_print(v2, size);

  printf("%f\n", inner_product(size, v1, v2));
}

void vector_print(double a[], int n)
{
  int k;
  printf("(");
  for(k=0; k<n; ++k){
    printf("%f", a[k]);
    if( k!=n-1 ){
      printf(",");
    }else{
      printf(")\n");
    }
  }
}

double inner_product(int n, double v[], double u[])
{
  int k;
  double s=0;
  for(k=0; k<n; ++k){
    s+=v[k]*u[k];
  }
  return(s);
}
