#include <stdio.h>
#include <math.h>

double newton(double,double);
double f(double);
double df(double);

int main()
{
  double x=5.0;
  double eps=1.0e-6;
  printf("%.10f\n",newton(x,eps));
}

double newton(double x0, double eps)
{
  double err=1.0,x=x0,y;
  while(err > eps){
    y=x-f(x)/df(x);
    err=fabs(y-x);
    x=y;
  }
  return(x);
}

//関数f(x)
double f( double x )
{
  double y=0.0;

  y=x*x*x-2.0;
  return(y);
}

//f(x)の導関数f'(x)
double df(double x )
{
  return(3.0*x*x);
}
