/* ラグランジュ補完の結果を確認する処理 */
#include <stdio.h>

int n=5;
double x[5]={-1.0,1.3,1.8,2.1,2.3};
double y[5]={-2.0,2.6,3.6,4.2,6.0};

double f(double, int, double *, double *);

int main()
{
  int k;
  double z;
  /* x,f(x)の値をx=-2から3まで0.1刻みで出力する。 */
  for(z=-2; z < 4; z+=0.1){
    printf( "%f %f\n", z,f(z, n, x,y));
  }
  /* 各x[k],y[k]について、f(x[k])=y[k] を確認する */
  for(k=0; k<n; ++k){
    printf("%lf\n",y[k]-f(x[k],n,x,y));
  }
}

double f(double x0, int n, double xn[], double yn[])
{
  int i,k;
  double s=0, t=1;

  /* f(x)の和の部分を与えるfor文 */
  for( i=0; i < n; ++i){
    t=yn[i];

    /* 積の部分を与えるfor文 */
    for( k=0; k < n; ++k){
      if( k != i ){
        t *= (x0-xn[k])/(xn[i]-xn[k]);
      }
    }
    s += t;
  }
  return(s);
}
