/* ルンゲクッタ法の処理を関数にまとめる */
#include <stdio.h>

/* ルンゲクッタ法の処理を実行する関数 */
void rk(double, double, int, double *);
double F(double);

int main()
{
#define N 100
  int i;
  double h=0.1;
  double y[N]; /* 配列yに数値解を格納 */
  rk(0.01, h, N, y);
  for(i=0; i<N; ++i){
    printf("%lf %lf\n",h*i, y[i]);
  }
}
void rk(double f0, double h, int T, double y[])
{
  int i;
  double k1,k2,k3,k4;
  double f;

  y[0]=f0;
  f=y[0];
  for( i=1; i < T; ++i ){
    k1=F(f);
    k2=F(f+k1*h/2);
    k3=F(f+k2*h/2);
    k4=F(f+k3*h);
    f=f+(k1+2*k2+2*k3+k4)*h/6;
    y[i]=f;
  }
}
double F(double t)
{
  return( t*(1-t) );
}
