#include <stdio.h>
#define N 4
double a[N][N]={{1,1,1,2},{5,6,-1,5},
  {3,2,8,-2},{1,0,5,1}};
double b[N]={1, 8, 11, 0};
/* 配列a,bを行列とベクトル風に表示する関数 */
void print(int);

double a1[N][N]={{1,1,1,2},{5,6,-1,5},
		 {3,2,8,-2},{1,0,5,1}};
double c[N]={0,0,0,0};

int main()
{
  int i,j,k;
  /* 配列a,bを行列とベクトル風に表示 */
  print(N);
  /* 前進消去 */
  for(k=0; k < N; ++k){
    /* 第k行について第k列以降を規格化 */
    /* 対角成分を変更するので、for文に注意 */
    b[k]=b[k]/a[k][k];
    for(j=N-1; j >= k; --j){
      a[k][j]=a[k][j]/a[k][k];
    }
    for(i=k+1; i < N; ++i){
      /* 第i行について第k列を0にする */
      b[i]=b[i]-b[k]*a[i][k];
      for(j=N-1; j >= k; --j){
	a[i][j]=a[i][j]-a[k][j]*a[i][k];
      }
    }
    /* 配列a,bの出力 */
    printf("k:%d\n",k);
    print(N);
  }
  /* 後退代入 */
  for(j=N-1; j > 0; --j){
    for(i=j-1; i >= 0; --i){
      b[i] = b[i] - b[j]*a[i][j];
      a[i][j] = 0;
    }
  }
  /* 交代代入の結果を出力 */
  printf("\n");
  print(N);

  printf("\n");
  /* 解を確かめる */
  for(i=0; i < N; ++i){
    for(j=0; j < N; ++j){
      c[i]+=a1[i][j]*b[j];
    }
    printf("%f\n",c[i]);
  }

}
/* 配列a,bを行列とベクトル風に表示する関数 */
void print(int n)
{
  int i,j;
  for(i=0; i < n; ++i){
    for(j=0; j < n; ++j){
      printf("%f ", a[i][j]);
    }
    printf("%f\n",b[i]);
  }
}
