/* 台形則 */
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

double f(double);

int main()
{
  int n=1;
  int k;
  double a=0, b=1;
  double h=(b-a)/n;
  double s0=(f(a)+f(b))*h/2;
  double s;
  double err=1.0;
  double eps=1.0e-4;
  /* 真の値との差errがepsよりも大きい間は計算を続ける。*/
  while( err > eps ){
    /* nを定めた場合の台形則の計算 */
    n=n*2;
    h=h/2;
    s=s0/2;
    for( k=1; k < n; k+=2 ){
      s+=f(a+k*h)*h;
    }
    err=fabs(s-s0);
    printf("%d %.10f %.10f\n", n, s,err);
    s0=s;
  }
}

double f(double x)
{
  return(exp(x));
}
