/* シンプソン法 */
#include <stdio.h>
#include <math.h>

double f(double);

int main()
{
  int k;
  double eps=1.0e-4;
  double err=1.0;

  int n=1;
  double a=0.0, b=1.0; 
  double h=(b-a)/n;
  double se0=(f(a)+f(b))*h/6;
  double so0=4*f((a+b)/2)*h/6;
  double s,se,so;
  /* while文で */
  while( eps < err ){
    n=n*2;
    h=h/2;
    se=se0/2+so0/4;
    so=0;
    for( k=0; k < n; ++k ){
      so+=4*f(a+k*h+h/2);
    }
    so *= h/6;
    err=fabs(so+se-so0-se0);
    printf("%d %.9f %.9f\n", n,so+se,err);
    se0=se;
    so0=so;
  }
}

double f(double x)
{
  return(exp(x));
}
