/* 修正オイラー法による常微分方程式の数値解 */
#include <stdio.h>

double F(double);

int main()
{
  int i, n=100;
  double h=0.1; /* 刻み幅 */
  double f;
  f=0.01; /* 初期値 */
  for( i=1; i < n; ++i ){
    f=f+h*F(f + h*F(f)/2);
    printf("%f %f\n", h*i, f);
  }
}

double F(double t)
{
  return( t*(1-t) );
}
