#include <stdio.h>

void rk(double, double, double, int, double *);
double F(double,double);

#define N 1000

int main()
{
  int i, n=N;
  double h=0.01;
  double y[N];
  double x,f;

  f=0.8;
  x=0.0;
  rk(x,f,h,n,y);
  for( i=0; i < n; ++i ){
    printf("%.10lf %.10lf\n", x, y[i]);
    x=x+h;
  }
}
double F(double x, double y)
{
  return( -x*y );
}
void rk(double x0, double f0, double h, int T,
       double y[])
{
  int i;
  double k1,k2,k3,k4;
  double x,f;
  x=x0;
  y[0]=f0;
  f=y[0];
  for( i=1; i < T; ++i ){
    k1=F(x,f);
    k2=F(x+h/2,f+k1*h/2);
    k3=F(x+h/2,f+k2*h/2);
    k4=F(x+h,f+k3*h);
    f=f+(k1+2*k2+2*k3+k4)*h/6;
    x=x+h;
    y[i]=f;
  }
}
